//+------------------------------------------------------------------+
//|                                                          OCO.mq4 |
//|                                    Copyright  2007, MQL Service |
//|                                        http://www.mqlservice.com |
//|                                        |
//| $Id: //mqlservice/mt4files/experts/scripts/OCO.mq4#1 $
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MQL Service"
#property link      "http://www.mqlservice.com"
#property show_inputs

//---- Parametres Externes --- changed the orders to my preference
extern double   BuyOrderPrice = 0.0000;
extern double   BuyLots = 0.01;
extern int      BuyStopLoss = 27;
extern int      BuyStopLoss2 = 27;
extern int      BuyTakeProfit = 37;
extern int      BuyTakeProfit2 = 47;
extern double   SellOrderPrice = 0.0000;
extern double   SellLots = 0.01;
extern int      SellStopLoss = 27;
extern int      SellStopLoss2 = 27; 
extern int      SellTakeProfit = 37;
extern int      SellTakeProfit2 = 47;
extern int      BuyOrderType = OP_BUYSTOP;
extern int      SellOrderType = OP_SELLSTOP;
extern int      Slippage = 6;
extern int      Magic = 20100000;

//---- Section Define
#define LABEL   "oco"
#define TIMEOUT 3

//---- Variables
double bsl,bsl2,ssl,ssl2,btp,btp2,stp,stp2;
int bt,bt2,st,st2;
bool cont = false;
bool flip = true;
int  err1,err;
      
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
   {
//----
      if(BuyStopLoss > 0)
         bsl = BuyOrderPrice - BuyStopLoss*Point;
      else
         bsl = 0.0;
      if(SellStopLoss > 0)
         ssl = SellOrderPrice + SellStopLoss*Point;
      else
         ssl = 0.0;
      if(BuyTakeProfit > 0)
         btp = BuyOrderPrice + BuyTakeProfit*Point;
      else
         btp = 0.0;
      if(SellTakeProfit > 0)
         stp = SellOrderPrice - SellTakeProfit*Point;
      else
         stp = 0.0;
//----
if(BuyStopLoss2 > 0)
         bsl2 = BuyOrderPrice - BuyStopLoss2*Point;
      else
         bsl2 = 0.0;
      if(SellStopLoss2 > 0)
         ssl2 = SellOrderPrice + SellStopLoss2*Point;
      else
         ssl2 = 0.0;
      if(BuyTakeProfit2 > 0)
         btp2 = BuyOrderPrice + BuyTakeProfit2*Point;
      else
         btp2 = 0.0;
      if(SellTakeProfit2 > 0)
         stp2 = SellOrderPrice - SellTakeProfit2*Point;
      else
         stp2 = 0.0;

//----                           
  
      bt = OrderSend(Symbol(), BuyOrderType, BuyLots, BuyOrderPrice, Slippage, bsl, btp, "Buy OCO", Magic, 0, Blue);
      if(CheckError()) 
         {
            RemoveOrder(st); 
            return(-1);
         }
      st = OrderSend(Symbol(), SellOrderType, SellLots, SellOrderPrice, Slippage, ssl, stp, "Sell OCO", Magic, 0, Red);
      if(CheckError())
         {
            RemoveOrder(bt);
            return(-1);
         }
  
      bt2 = OrderSend(Symbol(), BuyOrderType, BuyLots, BuyOrderPrice, Slippage, bsl2, btp2, "Buy OCO", Magic, 0, Blue);
      if(CheckError()) 
         {
            RemoveOrder(st2); 
            return(-1);
         }
      st2 = OrderSend(Symbol(), SellOrderType, SellLots, SellOrderPrice, Slippage, ssl2, stp2, "Sell OCO", Magic, 0, Red);
      if(CheckError())
         {
            RemoveOrder(bt2);
            return(-1);
         }
  
      
  
      cont = IsTradeAllowed();
      err1 = 0;
      while(cont)
         {
            if(flip) 
               ShowLabel();
            else
               HideLabel();
            flip = !flip;
            err = 0;

            if(OrderSelect(bt2, SELECT_BY_TICKET, MODE_TRADES))
               {
                  if(OrderType() <= OP_SELL)
                     {
                        RemoveOrder(st2);
                        cont = false;
                     }
               }
            else
               err++;

            if(OrderSelect(st2, SELECT_BY_TICKET, MODE_TRADES))
               {
                  if(OrderType() <= OP_SELL)
                     {
                        RemoveOrder(bt2);
                        cont = false;
                     }
               }
            else
               err++;
            if(err > 0)
               err1++;
            if(err1 > TIMEOUT) 
               cont = false;
            Sleep(500);
            cont = cont && IsTradeAllowed();
         }
  
      HideLabel();


 

//----
      return(0);

   }
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| script program VOID functions                                    |
//+------------------------------------------------------------------+
#include <stderror.mqh>
#include <stdlib.mqh>

void ShowLabel()
   {
      ObjectCreate(LABEL, OBJ_LABEL, 0, 0, 0);
      ObjectSet(LABEL, OBJPROP_CORNER, 2);
      ObjectSet(LABEL, OBJPROP_XDISTANCE, 4);
      ObjectSet(LABEL, OBJPROP_YDISTANCE, 2);
      ObjectSetText(LABEL, "Orders have been placed", 8, "Arial", Red);
      WindowRedraw();
   }

void HideLabel()
   {
      ObjectDelete(LABEL);
      WindowRedraw();
   }

bool CheckError()
   {
      int err = GetLastError();
      if(err == ERR_NO_ERROR) return(false);
      Print("ERROR #",err,": ",ErrorDescription(err));
      Alert("ERROR #",err,": ",ErrorDescription(err));
      return(true);
   }

void RemoveOrder(int ticket)
   {
      if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
         if(OrderType() <= OP_SELL)
            OrderClose(ticket, OrderLots(), OrderClosePrice(), Slippage);
         else
            OrderDelete(ticket);
      CheckError();
   }
   //+-----------------------------------------------+